Summary: MIPS32 simulator
Name: spim
Version: 7.3
Release: 3.%deployment_release_suffix.1
License: Free for non-commercial use
Group: Applications/Emulators
URL: http://www.cs.wisc.edu/~larus/spim.html
Source0: http://www.cs.wisc.edu/~larus/SPIM/%{name}-%{version}.tar.gz
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root
BuildRequires: binutils
BuildRequires: bison
BuildRequires: flex
BuildRequires: libXaw-devel
BuildRequires: libXp-devel
BuildRequires: rman
BuildRequires: tetex-dvips
BuildRequires: tetex-latex
BuildRequires: xorg-x11-proto-devel
Requires: xorg-x11-fonts-75dpi
%{?sampler_tags}
Source1: xev.c
Patch0: xspim-event-dispatch.patch
Patch1: yy_init-polarity.patch

%description 
SPIM is a self-contained simulator that will run MIPS32 assembly
language programs.  It reads and immediately executes assembly
language code for this processor.  SPIM provides a simple debugger and
minimal set of operating system services.

%{?sampler_description}

%prep
%setup -q
%patch0
%patch1

%build
%{!?deployment_scheme_flags: %define deployment_scheme_flags --sampler-scheme=branches --sampler-scheme=returns}
%define sampler_cc_flags --exclude-file=lex.yy.c --exclude-file=y.tab.c %deployment_scheme_flags
%sampler_prebuild
ln -s %{S:1} xspim
make CC="$CC" EXCEPTION_DIR=%_datadir/%name XOBJS='xev.o $(BASE_OBJS) $(BASE_XOBJS)' EXTRA_LOAD_FLAGS= -C xspim
make CC="$CC" EXCEPTION_DIR=%_datadir/%name -C spim

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT%_bindir
mkdir -p $RPM_BUILD_ROOT%_datadir/%name
mkdir -p $RPM_BUILD_ROOT%_mandir/man1
install xspim/xspim.exe $RPM_BUILD_ROOT%{_bindir}/xspim
install spim/spim $RPM_BUILD_ROOT%{_bindir}/spim
install CPU/exceptions.s $RPM_BUILD_ROOT%_datadir/%name
install Documentation/xspim.man $RPM_BUILD_ROOT%_mandir/man1/xspim.1x
install Documentation/spim.man $RPM_BUILD_ROOT%_mandir/man1/spim.1
%sampler_install %_bindir/xspim %_bindir/spim

%clean
rm -rf $RPM_BUILD_ROOT

%post
%{?sampler_post}

%files
%defattr(-,root,root,-)
%doc %{_mandir}/*/*
%doc ChangeLog
%doc Documentation/BLURB
%doc Documentation/SPIM.html
%doc Documentation/TeX/spim.ps
%doc README
%doc Tests
%{_bindir}/*
%{_datadir}/%{name}
%{?sampler_files}
%{?sampler_files_gconf}

%{?sampler_package}

%changelog
* Sun May 18 2008 Ben Liblit <liblit@cs.wisc.edu> - 7.3-3.%deployment_release_suffix.1
- Add patch from Jim Larus to fix yy_init polarity patch for flex >= 2.5.33.

* Fri May  2 2008 Ben Liblit <liblit@cs.wisc.edu> - 7.3-2.%deployment_release_suffix.1
- Require xorg-x11-fonts-75dpi for xspim's default font.

* Tue Nov 13 2007 Ben Liblit <liblit@cs.wisc.edu> - 7.3-1.%deployment_release_suffix.2
- Rebuild with sampler-1.6-1.

* Sat Jun  2 2007 Ben Liblit <liblit@cs.wisc.edu> - 7.3-1.%{deployment_release_suffix}.1
- Updated for release 7.3.

* Sun Oct 22 2006 Ben Liblit <liblit@cs.wisc.edu> - 7.2.1-2.%{deployment_release_suffix}.1
- Logging tweaks for sampler-1.4.4 and later.

* Fri Jun 30 2006 Ben Liblit <liblit@cs.wisc.edu> - 7.2.1-1.%{deployment_release_suffix}.2
- Rebuild with sampler-1.4.1.

* Mon Aug 29 2005 Ben Liblit <liblit@cs.wisc.edu> - 7.2.1-1.%{deployment_release_suffix}.1
- Updated for release 7.2.1.

* Tue Aug  2 2005 Ben Liblit <liblit@cs.wisc.edu> - 7.1-1.%{deployment_release_suffix}.4
- Rebuild with sampler-1.2.1.

* Tue May  3 2005 Ben Liblit <liblit@cs.berkeley.edu> - 7.1-1.%{deployment_release_suffix}.3
- Merge Stanford and standard deployment branches.

* Wed Mar 23 2005 Ben Liblit <liblit@cs.berkeley.edu> - 7.1.stan.2
- Configuration tweaks for Stanford CBI study.

* Mon Mar 21 2005 Ben Liblit <liblit@cs.wisc.edu> - 7.1.sam.2
- Rebuild with sampler-1.1 and new feedback reporting URL.

* Mon Jan 17 2005 Ben Liblit <liblit@cs.berkeley.edu> - 7.1-1
- Updated for release 7.1.
- Added hooks for sampled instrumentation.

* Sat Aug 28 2004 Ben Liblit <liblit@cs.berkeley.edu> 7.0-1
- Initial build.
